      SUBROUTINE CPRO (NSD,LT5C,NCPM,NCCD,NCCM,NPR,PT,IYE,TYE,CD)
C
C  SUBROUTINES TO GO WITH PROBPC6 PROGRAM ARRANGED AT KNOKKE IN
C  1990; REVISED IN MARCH 2000.
C
      INTEGER NSD(3),NCPM(2)
      INTEGER*2 IYE,TYE(30)
C
      LOGICAL*2 P(7),PT(30,41),CM(4),CMR(25),SWP,CD(5)
C
      COMMON/WHCC/CM,CMR,SWP
C     COMMON /KNOK/ WTC,FC,FCD
C
         LT3=0
         NN=0
         LT1=0
         LT2=0
         NN=NSD(1)+NSD(2)
         LT1=INT(6.*LT5C/10.)
         LT2=INT(LT5C/2.)
         LT3=INT(LT5C*.75)
         P(1)=NN.GE.90
         P(2)=NN.GT.LT1
         P(3)=NSD(1).GT.LT2
         P(4)=NSD(1).GT.LT3
         P(5)=NCPM(2).GE.90
         P(6)=NCCD.GE.45
         P(7)=NCCM.GE.45
      TYE(NPR)=IYE
      DO 1 I=1,7
    1 PT(NPR,I)=P(I)
      DO 2 I=8,11
    2 PT(NPR,I)=CM(I-7)
      DO 3 I=12,36
    3 PT(NPR,I)=CMR(I-11)
      DO 4 I=37,41
    4 PT(NPR,I)=CD(I-36)
      RETURN
      END
C
      SUBROUTINE CPSU(PT,NPR,LSTN,IND,TD,WTC,FC,FCD,TYE,KCHK,ANS)
C
      CHARACTER * 1 B, YES, S(14)
      CHARACTER * 4 PPRF, KOUN
      CHARACTER * 8 TD, ANS, AS(30),TRR
      CHARACTER * 16 NAME, KCHK
C
      INTEGER ND(3),NSD(3),LSTN(30),NCPM(2),
     1NTSU(3),IMEA(23),IVAR(30,23),ICV(30),ISTA(30),NPT(11),NTWI(3),
     2KPT(14),POS(4)
C
      REAL VER(30),WT(30),TMA(30),ST(30),VAR(30,23),SUM(30)
     1,MEAN(30),SUM2(30),STAN(30),PROB(11),VARI(30),CV(30),RPT(14),
     2RKPT(14),RDIF(14)
C
      LOGICAL*2 OPT(3),CR(2),V(3),W(4),X(2),XX(3),UD(3),XR(4),XE(3)
      LOGICAL*2 PT(30,41),CM(4),CMR(25),TH,SWP,E(14),F(30,14)
C
      INTEGER*2 TYE(30)
C
      COMMON/WHCC/CM,CMR,SWP
C
      DATA B /' '/
      DATA YES /'T'/
C
C      DEFINE FILE 15 (30,41,U,IND)
C
C
      KL=0
C      IND=1
      KO=0
C
C
      DO 11 I=1,NPR
      IF(KO.NE.0)GO TO 12
C
C
      WRITE (6,3)FC,FCD,KCHK
    3 FORMAT('1',/
     1' ',15X,'DETERMINATION OF SOIL MOISTURE REGIME ACCORDING TO'
     2' FRANKLIN NEWHALL SYSTEM OF COMPUTATION',/
     6' ',40X,' FORTRAN 77 VERSION BY A.VAN WAMBEKE',/
     3' ',19X,'(CORRECTION FOR TEMPERATURE IS',F4.1,'; SEASONAL AMPLITUD
     4E MODIFIED BY FACTOR ',F5.2,')'///' ',50X,'STATION: ',A16,//
     5' ',120('*'))
      WRITE(6,1)
    1 FORMAT(' ','*',12X,'*  MEAN SOIL  * TEMPERATURE *  CUMULATIVE ',  
     1'DAYS MCS    *    MAX.CONSECUTIVE DAYS THAT MCS IS    * MOISTURE *
     2'/
     2' ','*    YEAR    * TEMPERATURE *   REGIME    *    IN      *   WHE
     3N     * MOIST IN SOME PARTS **  DRY   *  MOIST *',10X,'*'/' ','*',
     412X,'*ANNUAL*SUMMER*',13X,    '*ONE YEAR IS *SOIL TEMP >5* IN ONE 
     5   *WHEN SOIL** AFTER  *  AFTER *  REGIME  *'/' ','*',12X,'*',2(6X
     6,'*'
     6),13X,'*DRY M/D MOI *DRY M/D MOI *  YEAR     *TEMP > 8 ** SUMMER *
     7 WINTER *',10X,'*'/' ','*',12X,'*',2(6X,'*'),13X,'*',2(12X,'*'),11
     8X,'*'                                                             
     8,9X,'** SOLST. * SOLST. *',10X,'*'/' ',120('*')  )                
C
C     READ DISK, WRITE LINES
C
   12 IND=LSTN(I)
      READ (7,58)KPR,NAME,TMA(I),ST(I),PPRF,TRR,(IVAR(I,J),J=1,10),   
     1ANS,(IVAR(I,JK),JK=11,20),KOUN,WT(I),POS,IVAR(I,21),IVAR(I,22),
     2TH
      WRITE (*,'(1X,A3\)') ' C>'
   58 FORMAT(I3,A16,2F5.1,A4,A8,10I3,A8,10I3,A4,F5.1,6I3,L1)  
      IVAR(I,23)=IVAR(I,5)+IVAR(I,4)
      VER(I)=ST(I)-WT(I)
      AS(I)=ANS
      WRITE(6,2) TYE(I),TMA(I),ST(I),PPRF,TRR,(IVAR(I,J),J=1,10),ANS    
      KO=KO+1
   11 CONTINUE
      IF(NPR.EQ.1)GO TO 4
      WRITE(6,201)
  201 FORMAT (' ',120('*'))
      DO 50 I=1,NPR
      DO 50 J=1,23
   50 VAR(I,J)=FLOAT(IVAR(I,J))
      SST=0.
      SWT=0.
      STMA=0.
      SST2=0.
      STM2=0.
      SDMA=0.
      STST=0.
      CTMA=0.
      CVST=0.
C
C      INTIALIZE SUMS
C
      DO 52 I=1,23
      SUM(I)=0.
      SUM2(I)=0.
   52 CONTINUE
C
C      COMPILE SUMS
C
      DO 51 I=1,23
      DO 51 J=1,NPR
      SUM(I)=SUM(I)+VAR(J,I)
      SUM2(I)=SUM2(I)+VAR(J,I)*VAR(J,I)
   51 CONTINUE
C
C      COMPILE TEMPERATURE DATA
C
      DO 54 I=1,NPR
      SST2=SST2+ST(I)*ST(I)
      SST=SST+ST(I)
      SWT=SWT+WT(I)
      STM2=STM2+TMA(I)*TMA(I)
      STMA=STMA+TMA(I)
   54 CONTINUE
C
C     CALCULATE STANDARD DEVIATIONS
C
      DO 57 I=1,23
      VARI(I)=(FLOAT(NPR)*SUM2(I)-SUM(I)*SUM(I))/FLOAT(NPR*(NPR-1))
      IF (VARI(I).LT.0.) VARI(I)=0.
      STAN(I)=SQRT(VARI(I))
   57 CONTINUE
C
C CALCULATE MEANS, DEVIATIONS FOR TEMPERATURE DATA
C
      RNPR=FLOAT(NPR)
      DO 53 I=1,23
      MEAN(I)=SUM(I)/RNPR
   53 CONTINUE
      AST=SST/RNPR
      AWT=SWT/RNPR
      ATMA=STMA/RNPR
      DO 56 I=1,10
   56 IMEA(I)=INT(MEAN(I))
      VST=(RNPR*SST2-SST*SST)/(RNPR*(RNPR-1.))
      IF (VST.LT.0.) VST=0.
      STST=SQRT(VST)
C
C      CALCULATE STAN. DEV. MEAN ANNUAL TEMPERATURE
C
      VTMA =(RNPR*STM2-STMA*STMA)/(RNPR*(RNPR-1.))
      IF (VTMA.LT.0.) VTMA=0.
      SDMA=SQRT(VTMA)
C
C      CALCULATE THE COEFFICENT OF VARIATION
C
      DO 62 I=1,10
      ISTA(I)=INT(STAN(I))
      IF (MEAN(I).EQ.0) GO TO 63
      CV(I)=STAN(I)/MEAN(I)*100
      ICV(I)=INT(CV(I))
   63 IF (IMEA(I).EQ.0) ISTA(I)=0
      IF (IMEA(I).EQ.0)ICV(I)=0
   62 CONTINUE
C
C     WRITE RESULTS
C
      WRITE (6,202)ATMA,AST,(IMEA(LL),LL=1,10)
      WRITE (6,203)SDMA,STST,(ISTA(LL),LL=1,10)
  203 FORMAT(' ','* STAND.DEV. *',F5.1,2X,F5.1,1X,'*',13X,'*',
     12(I3,2I4,' *')
     2,2X,I4,5X,'*  ',I4,3X,'**',2(2X,I4,2X,'*'),10X,'*')
      WRITE (6,204)(ICV(LL),LL=1,10)
  204 FORMAT (' ','* COEFF.VAR. *',13X,'*',13X,'*',
     12(I3,2I4,' *')
     2,2X,I4,5X,'*  ',I4,3X,'**',2(2X,I4,2X,'*'),10X,'*')
  202 FORMAT (' ','*   MEAN     *',F5.1,2X,F5.1,1X,'*',13X,'*'
     1,2(I3,2I4,' *')
     2,2X,I4,5X,'*  ',I4,3X,'**',2(2X,I4,2X,'*'),10X,'*')
    4 WRITE(6,5)TD
    5 FORMAT(' ',120('*')/' ','COMPUTED BY FORTRAN PROGRAM PROBPC6
     1',66X,'DATE ',A8)
    2 FORMAT(' ','*',3X,'19',I2,5X,'*',F5.1,2X,F5.1,1X,'*',A4,A8,1X, 
     1'*',2(I3,2I4,' *'),2X,I4,5X,'*  ',I4,3X,'**',2(2X,I4,2X,'*'),1X,
     2A8,' *')
C
C      WRITE PROBABILITY TABLE
C
      IF(NPR.EQ.1)GO TO 6
      CALL CUTRAN (NPR,RPT,PT,E,F)
      CALL CUF6 (E,ANS)
      WRITE (6,599) NAME
  599 FORMAT ('1',23X,'STATION :',A16//
     1' ',78('*')/
     2' ','*',6X,'*',16X,'OCCURENCE OF CONDITION',20X,'* MOISTURE *'/   
     3' ','* YEAR *',58X,'*          *'/
     4' ','*',6X,'*  1   2   3   4   5   6   7   8   9   10  11  12',   
     4'  13  14  *  REGIME  *'/
     5' ','*',6X,'*',58X,'*          *'/
     6' ',78('*'))
C                                                                       
      DO 102 I=1,NPR
      DO 41 KL=1,14
   41 S(KL)=B
      DO 106 K=1,14
  106 IF (F(I,K)) S(K)=YES
      WRITE (6,103)TYE(I),(S(J),J=1,14),AS(I)
C
  102 CONTINUE
      WRITE (6,104)
C
  103 FORMAT (' ','* 19',I2,' *  ',14(A1,3X),'*',1X,A8,' *')
  104 FORMAT (' ',78('*'))
      DO 300 I=1,14
      KPT(I)=INT(RPT(I))
      RKPT(I)=FLOAT (KPT(I))
      RDIF(I)=RPT(I)-RKPT(I)
  300 IF (RDIF(I).GT..5) KPT(I)=KPT(I)+1
      WRITE (6,105)KPT
  105 FORMAT(' ','* FREQ.*',14I4,'  *',10X,'*')
      DO 72 I=1,14
   72 S(I)=B
      DO 73 I=1,14
   73 IF (E(I)) S(I)=YES
      WRITE (6,107) S,ANS
107   FORMAT (' ','* COND.*  ',14(A1,3X),'*',1X,A8,' *')
      WRITE (6,104)
      WRITE (6,400) TD
  400 FORMAT (' ','COMPUTED BY FORTRAN PROGRAM PROBPC6',24X,'DATE 
     1',A8)
    6 ATMA=0.
      AST=0.
      DO 450 LK=1,10
      IMEA (LK)=0
      ISTA (LK)=0
      ICV (LK)=0
  450 CONTINUE
      RETURN
      END
      SUBROUTINE CUTRAN (NPR,RPT,PT,E,F)
      REAL RPT(14)
      LOGICAL*2 F(30,14), PT(30,14), E(14)
      DO 1 I=1,NPR
      F(I,1)=PT(I,3)
      F(I,2)=PT(I,5)
      F(I,3)=PT(I,6)
      F(I,4)=PT(I,7)
      F(I,5)=PT(I,22)
      F(I,6)=PT(I,24)
      F(I,7)=PT(I,32)
      F(I,8)=PT(I,1)
      F(I,9)=PT(I,2)
      F(I,10)=PT(I,4)
C TEMPERATURE
      F(I,11)=PT(I,10)
      F(I,12)=PT(I,11)
      F(I,13)=PT(I,12)
      F(I,14)=PT(I,18)
C
    1 CONTINUE
      DO 5 I=1,14
    5 E(I)=.FALSE.
      DO 2 I=1,14
    2 RPT(I)=0.
C
C
      RPR=FLOAT(NPR)
C
      DO 3 I=1,14
      DO 3 J=1,NPR
      IF (F(J,I)) RPT(I)=RPT(I)+1
    3 CONTINUE
C
       DO 4 I=1,14
      RPT(I)=RPT(I)/RPR*100.
      IF (RPT(I).GE.50.) E(I)=.TRUE.
    4 CONTINUE
      IF (RPT(3).LT.60.) E(3)=.FALSE.
      IF (RPT(4).LT.60.) E(4)=.FALSE.
      RETURN
      END
      SUBROUTINE CUF6 (E,ANS)
C
C  DEFINITION OF MOISTURE REGIMES
C
      CHARACTER * 8 NMRE(6), ANS
C
      LOGICAL*2 SWM,SWP,E(14)                                           
      LOGICAL*2 CM(4),SWT,CD(5),CMR(25)
C
      COMMON /WHCC/ CM,CMR,SWP
C
      DATA NMRE /'ARIDIC ','XERIC   ','USTIC   ','UDIC    ',        
     1'PERUDIC ','UNDEFIN.'/
C
C  INITIALIZE
C
      DO 5 I=1,5
    5 CD(I)=.FALSE.
      DO 4 I=1,4
    4 CM(I)=.FALSE.
      DO 26 I=1,25
   26 CMR(I)=.FALSE.
C
C  PERUDIC
C
C  ARIDIC
C
      CMR(1)=E(13)
      CM(1)=E(1)
      CM(2)=.NOT.E(2)
      CMR(2)=CM(1).AND.CM(2)
      CD(1)=CMR(1).AND.CMR(2)
C
C  XERIC
C
      CMR(3)=E(3)
      CMR(4)=E(4)
      CMR(5)=CMR(3).AND.CMR(4)
      CMR(6)=E(11).AND.E(12)
      CD(2)=(.NOT.CD(1)).AND.CMR(5).AND.CMR(6)
C
C  USTIC
C
      CMR(7)= E(14)
      CMR(8)=.NOT.E(11)
      CMR(9)= .NOT.E(12)
      CMR(10)=CMR(8).OR .CMR(9)
      CMR(11)=E(5)
      CMR(12)=CMR(10).AND.CMR(11)
      CMR(13)=E(6)
      CMR(14)=E(2)
      CMR(15)=CMR(13).OR.CMR(14)
      CMR(16)=CMR(12).AND.CMR(15)
C
      CMR(17)=.NOT.E(1)
      CMR(18)=.NOT.CMR(5)
      CMR(19)=CMR(6).AND.CMR(11).AND.CMR(17).AND.CMR(18)
      CMR(25)=CMR(6).AND.CMR(11).AND.(.NOT.CMR(17)).AND.(CMR(14)).
     1AND.CMR(18)
      CMR(20)=CMR(16).OR.CMR(19).OR.CMR(25)
      CD(3)= CMR(7).AND.CMR(20)
C
C  UDIC
C
      CMR(21)=.NOT.E(5)
      CMR(22)=E(11).AND.E(12)
      CMR(23)=CMR(22).AND.CMR(3)
      CMR(24)=.NOT.CMR(23)
      CD(4)=CMR(21).AND.CMR(24)
C
C  WRITE RESULTS
C
      IF (E(7)) GO TO 68
      SWM=.FALSE.
      DO 25 JI=1,4
      IF(.NOT.CD(JI)) GO TO 25
      ANS=NMRE(JI)
      SWM=.TRUE.
   25 CONTINUE
      IF(SWM) GO TO 30
      ANS=NMRE(6)
      GO TO 30
   68 ANS=NMRE(5)
   30 RETURN
      END
      SUBROUTINE CALE (STAT,TD,NPR,FANS)
      CHARACTER * 4 NMTH (12)
      CHARACTER * 8 TANS(30),FANS, TD
      CHARACTER * 16 STAT
C
      INTEGER*2 TDAY(30,360),TYE(30)
C
      DATA NMTH /' JAN',' FEB',' MAR',' APR',' MAY',' JUN',
     2 ' JUL',' AUG',' SEP',' OCT',' NOV',' DEC'/
C      DEFINE FILE 14(30,184,U,INZ)
      IPAG=0
C
C    SET UP OF MATRIX
C
      DO 1 I=1,NPR
      INZ=I
      READ(9,59)TYE(I),(TDAY(I,K), K=1,360 ),TANS(I)
   59 FORMAT(I4,360I1,A8)
    1 CONTINUE
C
C   WRITE  PAGES
C
   10 IPAG=IPAG +1
      NPAG=IPAG*6
      WRITE(6,5)IPAG,STAT
    5 FORMAT('1',65X,'PAGE',I2/' ',15X,'MOISTURE CONDITION CALENDARS'
     2,' ACCORDING TO'/' ',17X,'MATHEMATICAL MODEL OF F.NEWHALL(1972)' 
     3,//' ',26X,'STATION:',3A4 //' ',12X,'(1)=COMPL.DRY  ',
     4'(2)=PARTLY DRY  (3)=COMPL.MOIST'// 
     5' ','DAYS',35X,'DAYS'/
     6' ','--------->11-------->21------>30'
     77X,'--------->11-------->21------>30'/
     8' ',33X,'MONTHS')
      NNPR=NPR-(IPAG-1)*6
      IF(NPAG.LE.NPR)GO TO 11
      RNPR=FLOAT(NNPR)
      COUN=RNPR/2.
      KO=INT(COUN)
      GO TO 12
   11 KO=3
   12 IF(KO.EQ.0)GO TO 7
      DO 2 I=1,KO
      IE=I*2 + (IPAG-1)*6
      IB=IE-1
      WRITE(6,13)TYE(IB),TYE(IE)
      WRITE (6,23)(TANS(KK),KK=IB,IE)
      DO 4 L=1,12
      M1=30*L
      N1=M1-29
      WRITE(6,3)(TDAY(IB,KK),KK=N1,M1),NMTH(L),
     3          (TDAY(IE,KK),KK=N1,M1)
    3 FORMAT(' ',3(10I1,1X),A4,2X,3(10I1,1X))
   13 FORMAT(' ',11X,'YEAR 19',I2,30X,'YEAR 19',I2)
    4 CONTINUE
   23 FORMAT(' ',11X,'(',A8,')',29X,'(',A8,')')
      WRITE (6,24)
   24 FORMAT(' ')
    2 CONTINUE
C
C    DECIDE ON NEW PAGE
C
      IF(NPAG.LT.NPR)GO TO 15
   16 IF(NPAG.LT.NPR)GO TO 10
C
C    FINALIZE
C
      IF((NNPR-KO*2).GT.0)GO TO 7
      WRITE (6,40)
  40   FORMAT ('0')
      WRITE (6,8)NPR,TYE(1),TYE(NPR),FANS,TD
    8 FORMAT('0',38X,'THE CLASSIFICATION FOR ',I2,' YEARS',/
     2' ',38X,'BETWEEN 19',I2 ,' AND 19',I2,' IS:',A8//
     3' ','COMPUTED BY PROGRAM PROBPC6, FEB 00',26X,'DATE:',A8)
      GO TO 99
    7 WRITE (6,14)TYE(NPR)
      WRITE (6,31)TANS(NPR)
   14 FORMAT(' ',31X,'YEAR 19',I2)
      DO 81 L=1,12
      M1=30*L
      N1=M1-29
      WRITE (6,30)NMTH(L),(TDAY(NPR,KK),KK=N1,M1)
   30 FORMAT(' ',14X,A4,2X,3(10I1,1X))
   81 CONTINUE
   31 FORMAT(' ',31X,'(',A8,')')
      WRITE (6,40)
      WRITE(6,8)NPR,TYE(1),TYE(NPR),FANS,TD
      GO TO 99
   15 WRITE(6,9)TD
    9 FORMAT('0','COMPUTED BY PROGRAM VW 18,FEB 00',26X,'DATE',
     1A8)
      GO TO 16
   99 RETURN
      END
C
      SUBROUTINE WH04TH (MT,RLA1,RLA2,APE,IH)
C
C  CALCULATION OF THORNTHWAITE EVAPOTRANSPIRATION
C
      REAL SWI, A, CF, RLA
      INTEGER KI, KK, KL, NROW, I, RLA1, RLA2
      REAL ZPE(24), ZT(24), FN(31,12), RN(31), FS(13,12)
      REAL RS(13),MT(12),MWI(12),UPE(12),APE(12)
      CHARACTER * 1 NO, SO, IH
      LOGICAL*2 SWPU
C
C   INITIALIZE
C
      DATA NO /'N'/, SO /'S'/
      DATA ZPE /135.,139.5,143.7,147.8,151.7,155.4,158.9,162.1,
     1165.2,168.,170.7,173.1,175.3,177.2,179.,180.5,181.8,182.9,183.7,
     2184.3,184.7,184.9,2*185./
      DATA ZT /26.5,27.,27.5,28.,28.5,29.,29.5,30.,30.5,31.,31.5,
     132.,32.5,33.,33.5,34.,34.5,35.,35.5,36.,36.5,37.,37.5,38. /
      DATA FN /1.04,1.02,1.,.97,.95,.93,2*.92,2*.91,2*.9,.89,2*.8
     18,2*.87,.86,2*.85,.84,.83,.82,2*.81,.8,.79,.77,.76,.75,.74,.94,.93
     2,2*.91,.9,.89,3*.88,3*.87,2*.86,3*.85,3*.84,3*.83,2*.82,2*.81,2*.8
     3,.79,.78,1.04,22*1.03,8*1.02,1.01,1.02,1.03,1.04,1.05,2*1.06,3*1.0
     47,3*1.08,3*1.09,3*1.1,3*1.11,2*1.12,3*1.13,3*1.14,1.15,1.04,1.06,
     51.08,1.11,1.13,2*1.15,2*1.16,1.17,2*1.18,2*1.19,1.20,2*1.21,1.22,
     62*1.23,1.24,1.25,2*1.26,1.27,1.28,1.29,1.30,1.31,1.32,1.33,1.01,1.
     703,1.06,1.08,1.11,1.14,2*1.15,2*1.16,1.17,1.18,1.19,2*1.20,1.21,1.
     822,1.23,2*1.24,1.25,1.26,1.27,1.28,2*1.29,1.31,1.32,1.33,1.34,1.36
     9,1.04,1.06,1.08,1.12,1.14,2*1.17,2*1.18,1.19,2*1.2,1.21,2*1.22,1.2
     13,1.24,2*1.25,1.26,2*1.27,1.28,1.29,1.30,1.31,1.32,1.33,1.34,1.35,
     21.37,1.04,1.05,1.07,1.08,1.11,2*1.12,3*1.13,2*1.14,2*1.15,3*1.16,
     32*1.17,2*1.18,2*1.19,2*1.20,1.21,2*1.22,1.23,1.24,1.25,2*1.01,7*1.
     402,9*1.03,10*1.04,2*1.05,1.06,1.04,1.03,1.02,1.01,1.,3*.99,5*.98,
     55*.97,4*.96,3*.95,2*.94,3*.93,.92,1.01,.99,.98,.95,.93,2*.91,3*.9,
     62*.89,2*.88,.87,2*.86,.85,2*.84,.83,2*.82,.81,.8,2*.79,.78,.77,2*.
     576,
     71.04,1.02,.99,.97,.94,2*.91,2*.9,.89,2*.88,.87,2*.86,.85,.84,2*.83
     8,.82,.81,.8,.79,.77,.76,.75,.74,.73,.72,.71,.7/
      DATA RN /0.,5.,10.,15.,20.,25.,26.,27.,28.,29.,30.,31.,32.,33.,
     134.,35.,36.,37.,38.,39.,40.,41.,42.,43.,44.,45.,46.,47.,48.,49.,
     250./
      DATA FS /1.06,1.08,1.12,1.14,1.17,1.20,1.23,1.27,1.28,1.30
     1,1.32,1.34,1.37,.95,.97,.98,1.,1.01,1.03,1.04,1.06,1.07,1.08,1.1,
     21.11,1.12,1.04,4*1.05,2*1.06,4*1.07,2*1.08,1.,.99,.98,.97,.96,.95
     3,.94,.93,2*.92,.91,.9,.89,1.02,1.01,.98,.96,.94,.92,.89,.86,.85,
     4.83,.82,.8,.77,.99,.96,.94,.91,.88,.85,.82,.78,.76,.74,.72,.7,.67
     5,1.02,1.,.97,.95,.93,.9,.87,.84,.82,.81,.79,.76,.74,1.03,1.01,1.,
     6.99,.98,.96,.94,2*.92,.91,.9,.89,.88,9*1.,4*.99,1.05,1.06,1.07,
     71.08,1.1,1.12,1.13,1.15,1.16,2*1.17,1.18,1.19,1.03,1.05,1.07,1.09
     8,1.11,1.14,1.17,1.20,1.22,1.23,1.25,1.27,1.29,1.06,1.1,1.12,1.15,
     91.18,1.21,1.25,1.29,1.31,1.33,1.35,1.37,1.41/
      DATA RS /5.,10.,15.,20.,25.,30.,35.,40.,42.,44.,46.,48.,50./
C
C    UPE  UNADJUSTED POT.EVAP.
C    APE  ADJUSTED EVAPOTRANSP.
C    MWI  MONTHLY HEAT INDEX
C
      DO 10 I=1,12
         UPE(I)=0.
         APE(I)=0.
   10    MWI(I)=0.
C
C   CALCULATE HEAT INDEX
C
      RLA=RLA1+RLA2/60.
      A=0.
      SWI=0.
      DO 20 I=1,12
         IF (MT(I).LE.0.) GO TO 20
         MWI(I)= (MT(I)/5.)**1.514
   20    CONTINUE
      DO 30 I=1,12
   30    SWI=SWI+MWI(I)
      A=(675.E-9*SWI**3)-(771.E-7*SWI**2)+(1792.E-5*SWI)+(.49239)
C
C CALCULATE UNADJ.POT.EVAP.
C
      DO 80 I=1,12
         IF (MT(I).LE.0.) GO TO 80
         IF (MT(I).LT.26.5) GO TO 70
         IF (MT(I).GE.38.0) GO TO 60
         DO 40 KI=1,24
            KL=KI+1
            KK=KI
            IF (MT(I).GE.ZT(KI).AND.MT(I).LT.ZT(KL)) GOTO 50
   40       CONTINUE
   50    UPE(I)=ZPE(KK)
         GO TO 80
   60    UPE(I)=185.
         GO TO 80
   70    UPE(I)=16.*((10.*MT(I)/SWI)**A)
   80    CONTINUE
      IF (IH.EQ.NO) GO TO 90
      IF (IH.EQ.SO) GO TO 130
C
C  ADJUST FOR NORTHERN HEMISPHERE
C
   90 NROW=0
      DO 100 I=1,31
         IF (RLA.LT.RN(I)) GOTO 110
  100    NROW=NROW+1
  110 DO 120 I=1,12
         IF (UPE(I).LE.0.) GO TO 120
         APE(I)=UPE(I)*FN(NROW,I)
  120    CONTINUE
      GOTO 210
C
C   ADJUST FOR SOUTH HEMISPHERE
C
  130 NROW=0
      DO 140 I=1,13
         IF (RLA.LT.RS(I)) GOTO 150
  140    NROW=NROW+1
  150 IF (NROW.NE.0) GOTO 170
      NROW=1
      DO 160 I=1,12
         IF (UPE(I).LE.0.) GO TO 160
         CF=(FS(1,I)-FN(1,I))* (RLA1*60. +RLA2) /300.
         CF=FN(1,I)+CF
         APE(I)=UPE(I)*CF
  160    CONTINUE
      GOTO 210
  170 DO 200 I=1,12
         IF (UPE(I).LE.0.) GO TO 200
         IF (NROW.GE.13) GO TO 180
         IF (FS(NROW,I).EQ.FS(NROW+1,I)) GO TO 180
         CF=((FS(NROW+1,I)-FS(NROW,I))*(((RLA1-RS(NROW))*60.)+RLA2))/((
     1    RS(NROW+1)-RS(NROW))*60.)
         CF=FS(NROW,I)+CF
         GO TO 190
  180    CF=FS(NROW,I)
  190    APE(I)=UPE(I)*CF
  200    CONTINUE
  210 RETURN
      END
C
C
      SUBROUTINE WH04T1(CR,NBD,NED,T,NP)
C
      INTEGER NBD(6),NED(6),ND(12),NP,I,J,IA,IZ,M0,M1,M2,K
      INTEGER LE,NPRO,IB,IE
      REAL T(12),CR
      LOGICAL*2 SWT,C(14)
C
C  INITIALIZE
C
      DO 5 I=1,12
    5    ND(I)=0
      SWT=.FALSE.
      K=1
      IA=30
      IZ=30
      IF(CR.EQ.8.) GO TO 10
      IA=36
      IZ=25
C
C
   10 DO 30 I=1,12
         DO 15 J=1,14
   15       C(J)=.FALSE.
C
C  NUMBER MONTHS
C
         M0=I-1
         M1=I
         M2=I+1
         IF (M2.GT.12) M2=M2-12
         IF (M0.LT.1) M0=M0+12
C
C  DEFINE CONDITIONS
C
         C( 1)=T(M1).LT.CR
         C( 2)=T(M2).GT.CR
         C( 3)=T(M0).LT.CR
         C( 4)=T(M1).EQ.CR
         C( 5)=T(M2).GT.CR
         C( 6)=T(M2).LT.CR
         C( 7)=T(M1).GT.CR
         C( 8)=T(M0).GT.CR
         C( 9)=C(1).AND.C(2)
         C(10)=C(3).AND.C(4).AND.C(5)
         C(11)=C(9).OR.C(10)
         C(12)=C(6).AND.C(7)
         C(13)=C(8).AND.C(6).AND.C(4)
         C(14)=C(12).OR.C(13)
C
C  PROCEED
C
         IF (C(11)) GO TO 20
         IF (C(14)) GO TO 25
         GO TO 30
   20    ND(K)=M0*30+IA+INT(30.*(CR-T(M1))/(T(M2)-T(M1)))
         IF (ND(K).GT.360) ND(K)=ND(K)-360
         K=K+1
         SWT=.TRUE.
         GO TO 30
   25    ND(K)=M0*30+IZ+INT(30.*(T(M1)-CR)/(T(M1)-T(M2)))
         IF (ND(K).GT.360) ND(K)=ND(K)-360
         K=K+1
         SWT=.FALSE.
   30    CONTINUE
C
C  ARRANGE RESULTS
C
      IF (.NOT.SWT) GO TO 40
      LE=K-2
      NPRO=ND(1)
      DO 35 I=1,LE
   35    ND(I)=ND(I+1)
      ND(LE+1)=NPRO
   40 NP=(K-1)/2
      DO 45 I=1,NP
         IB=2*I-1
         IE=2*I
         NBD(I)=ND(IB)
   45    NED(I)=ND(IE)
C
C  END
C
      RETURN
      END
C
C
      SUBROUTINE WH04T2(C,CD,T,H,CR,REG,TMA,ST,WT,DIF)
      REAL T(12)
      INTEGER I
      CHARACTER * 1 HH(2), H
      LOGICAL*2 CR(11),REG(10)
      REAL SUMT, TMA, ST, WT, DIF, C, CD, AT1, AT2, CS
C
      DATA HH /'N', 'S'/
C
      SUMT=0.
      DO 10 I=1,12
   10 SUMT=SUMT + T(I)
      TMA= SUMT/12.+C
      AT1=(T(6)+T(7)+T(8))/3.+C
      AT2=(T(1)+T(2)+T(12))/3.+C
      IF (H.EQ.HH(1)) THEN
         ST = AT1
         WT = AT2
        ELSEIF (H.EQ.HH(2)) THEN
         ST = AT2
         WT = AT1
        ENDIF
      DIF= ABS(AT1-AT2)
      CS=DIF*(1.-CD)/2.
      CR(1)=TMA.LT.0.
      CR(2)=(0..LE.TMA).AND.(TMA.LT.8.)
      CR(3)=(ST-CS).LT.15.
C
C   THE DIFFERENCE CRITERION WAS CHANGED TO 6 ON FEB 10, 2000
C
      CR(7)=(DIF*CD).GT.6.
      CR(8)=(TMA.GE.8.).AND.(TMA.LT.15.)
      CR(9)=(TMA.GE.15.).AND.(TMA.LT.22.)
      CR(10)=TMA.GE.22.
      CR(11)=TMA.LT.8.
C
      REG(1)= CR(1)
      REG(2)=CR(2).AND.CR(3)
      REG(3)=CR(11).AND. (.NOT.CR(3)).AND.CR(7)
      REG( 4)=CR(8).AND.CR(7)
      REG( 5)=CR(9).AND.CR(7)
      REG( 6)=CR(10).AND.CR(7)
      REG( 7)=CR(11).AND.(.NOT.CR(7)).AND.(.NOT.CR(3))
      REG( 8)=CR(8 ).AND.(.NOT.CR(7))
      REG( 9)=CR(9 ).AND.(.NOT.CR(7))
      REG(10)=CR(10).AND.(.NOT.CR(7))
      ST=ST-CS
      WT=WT+CS
      DIF=ST-WT
      RETURN
      END
C
C
      SUBROUTINE WH04T4 (NTD,NBD,NED,NBD8,NED8)
C
      CHARACTER * 1 NTD(360),KL(3)
      INTEGER * 2 MARK(24),ITM,NS,IMA
      INTEGER NBD(6),NED(6),NBD8(6),NED8(6),KR(24)
      INTEGER ITEMP,I,K,J,N,NUL,KK,IPL,NN,IE,IB
      LOGICAL*2 SWT
C
      DATA KL /'-', '5', '8'/
C
C     INITIALIZE VECTOR KR
C
      DO 5 I=1,24
    5    KR(I)=0
C
C     SHORTCUTS WHEN ONLY ONE SEASON
C
      IF (NBD(1).LT.0.AND.NBD8(1).LT.0) GO TO 80
      IF (NBD(1).EQ.0.AND.NBD8(1).LT.0) GO TO 90
      IF (NBD8(1).LT.0) NBD8(1)=0
C
C     FILL KR VECTOR AND MARK VECTOR
C
      DO 10   I=1,6
         KR(I)=NBD(I)
   10    MARK(I)=2
      DO 15 I=7,12
         K=I-6
         IF (NED(K).EQ.0) GO TO 15
         KR(I)=NED(K)+1
         IF (KR(I).GT.360) KR(I)=1
         MARK(I)=1
   15    CONTINUE
      DO 20 I=13,18
         K=I-12
         KR(I)=NBD8(K)
   20    MARK(I)=3
      DO 25 I=19,24
         K=I-18
         IF (NED8(K).EQ.0) GO TO 25
         KR(I)=NED8(K)+1
         IF (KR(I).GT.360) KR(I)=1
         MARK(I)=2
   25    CONTINUE
C
C     ARRANGE SEQUENCE
C
      N=23
      DO 35 I=1,23
         SWT=.FALSE.
         DO 30 J=1,N
            IF (KR(J).LE.KR(J+1)) GO TO 30
            ITEMP=KR(J)
            ITM=MARK(J)
            KR(J)=KR(J+1)
            MARK(J)=MARK(J+1)
            KR(J+1)=ITEMP
            MARK(J+1)=ITM
            SWT=.TRUE.
   30       CONTINUE
         IF (.NOT.SWT) GO TO 40
   35    N=N-1
C
C     PUT KR FIGURES IN FRONT OF ZEROS
C
   40 IMA=MARK(24)
      NUL=0
      DO 45 I=1,24
         IF (KR(I).EQ.0) NUL=NUL+1
   45    CONTINUE
      DO 50 I=1,24
         KK=I
         IPL=I+NUL
         IF (IPL.GT.24) GO TO 55
         KR(I)=KR(IPL)
   50    MARK(I)=MARK(IPL)
   55 DO 60 I=KK,24
   60    KR(I)=0
C
C     ASSIGN MARKS TO NTD
C
C        WHEN FIRST SEASON STARTS JAN.1
C
      IF (KR(1).EQ.1) GO TO 70
C
C        WHEN FIRST SEASON STARTS OTHER DAY
C
      IE=KR(1)-1
      DO 65 I=1,IE
   65    NTD(I)=KL(IMA)
   70 NN=24-NUL
      DO 75 I=1,NN
         NS=MARK(I)
         IB=KR(I)
         IE=KR(I+1)-1
         IF (KR(I+1).EQ.0) IE=360
         DO 75 J=IB,IE
            NTD(J)=KL(NS)
   75       CONTINUE
      GO TO 100
   80 DO 85 I=1,360
   85    NTD(I)=KL(1)
      GO TO 100
   90 DO 95 I=1,360
   95    NTD(I)=KL(2)
  100 RETURN
      END
C
C
      SUBROUTINE WH04B1(IM)
C
C  FILLING OR DEPLETING SLOTS WITH LIGHT PRECIPITATION
C
      INTEGER DP(64), I3, NR, IM
      REAL DR(64)
      REAL MP(12),MPE(12),SL(64),NPE,LP
      REAL FSL, ESL
      LOGICAL *2 MSW,C(3)
C
      COMMON /WHMM/  MP,MPE,SL,FSL,C
C
      DATA DP /8,7,16,6,15,24,5,14,23,32,4,13,22,31,40,3,12,
     1  21,30,39,48,2,11,20,29,38,47,56,1,10,19,28,37,46,55,64,9,18,
     2  27,36,45,54,63,17,26,35,44,53,62,25,34,43,52,61,33,42,51,60,
     3  41,50,59,49,58,57/
      DATA DR /1.,1.,1.,1.,1.02,1.03,1.05,1.07,1.09,1.11,1.13,1.15,
     1  1.17,1.19,1.21,1.23,1.26,1.28,1.31,1.34,1.37,1.40,1.43,1.46,
     2  1.49,1.53,1.57,1.61,1.65,1.69,1.74,1.78,1.84,1.89,1.95,2.01,
     3  2.07,2.14,2.22,2.30,2.38,2.47,2.57,2.68,2.80,2.93,3.07,3.22,
     4  3.39,3.58,3.80,4.03,4.31,4.62,4.98,9*5./
C
      MSW = .FALSE.
      LP = MP(IM) / 2.
      NPE = (LP-MPE(IM)) / 2.
      IF (NPE.LE.0.) GOTO 10
      MSW = .TRUE.
      GOTO 30
   10 NPE = 0. - NPE
   30 DO 110 I3 = 1,64
         IF (.NOT.MSW) GO TO 70
         IF (SL(I3).GE.FSL) GOTO 110
         ESL = FSL - SL(I3)
         IF(ESL.GE.NPE) GOTO 50
         SL(I3) = FSL
         NPE = NPE - ESL
         GO TO 110
  50     SL(I3) = SL(I3) + NPE
         GO TO 130
  70     NR = DP(I3)
         IF (SL(NR).LE.0.) GOTO 110
         RPE = SL(NR) * DR(I3)
         IF (NPE.LE.RPE) GO TO 90
         SL(NR) = 0.
         NPE = NPE-RPE
         GO TO 110
  90     SL(NR) = SL(NR) - (NPE/DR(I3))
         NPE = 0.
         GO TO 130
  110    CONTINUE
  130 RETURN
      END
C
      SUBROUTINE CUEXPL
      WRITE (6,3)
    3 FORMAT('1',/
     1' ',15X,'EXPLANATIONS OF FREQUENCY COLUMNS NUMBERS',/
     210X,' DEFINING SOIL CONDITIONS DIAGNOSTIC OF MOISTURE REGIMES',/)
      WRITE (6,4)
    4 FORMAT('0',5X,'CONDITION 1',//
     25X,' Number of cumulative days that MCS is completely dry when',/
     35X,' soil temperature is >5 degrees C. This number should be >',/
     45X,' 1/2 time that soil temperature is above 5. Condition',/
     55X,' is used for definition of ARIDIC and should be > 50 %.')
      WRITE (6,5)
    5 FORMAT('0',5X,'CONDITION 2',//
     25X,' Number of consecutive days that MCS is moist in some',/
     35X,' or all parts when soil temperature is >8 degrees C.',/
     45X,' Condition is met when this number is > 90. The frequency',/
     55X,' should be > 50 % and then eliminates soils from ARIDIC.')
      WRITE (6,6)
    6 FORMAT('0',5X,'CONDITION 3',//
     25X,' Number of consecutive days that MCS is dry in all parts',/
     35X,' during the 4 months that follow the summer solstice.',/
     45X,' Condition is met when this number is > 45. The frequency',/
     55X,' should be > 60 % for a regime to be XERIC.')
      WRITE (6,7)
    7 FORMAT('0',5X,'CONDITION 4',//
     25X,' Number of consecutive days that MCS is moist in all parts',/
     35X,' during the 4 months that follow the winter solstice.',/
     45X,' Condition is met when this number is > 45. The frequency',/
     55X,' should be > 60 % for a regime to be XERIC.')
      WRITE (6,8)
    8 FORMAT('0',5X,'CONDITION 5',//
     25X,' Number of cumulative days that MCS is dry in some',/
     35X,' or all parts in one year.',/
     45X,' Condition is met when this number is > 90. The frequency',/
     55X,' should be > 50 % and is diagnostic for USTIC.')
      WRITE (6,9)
    9 FORMAT('0',5X,'CONDITION 6',//
     25X,' The number of cumulative days that MCS is moist in some',/
     35X,' or all parts is >180 days in one year. The frequency',/
     55X,' should be > 50 % and is used for some USTIC regimes.')
      WRITE (6,10)
   10 FORMAT('0',5X,'CONDITION 7',//
     25X,' All monthly precipitations exceed monthly potential',/
     35X,' evapotranspirations. The frequency requirement is set at',/
     45X,' 50% or higher. The condition is diagnostic for PERUDIC.')
      WRITE (6,11)
   11 FORMAT('1',5X,'CONDITION 8',//
     25X,' Number of cumulative days that MCS is dry in some',/
     35X,' or all parts when soil temperature is >5 degrees C.',/
     45X,' Condition is met when this number is > 90. The frequency',/
     55X,' should be > 50 % and is diagnostic for USTIC.')
      WRITE (6,12)
   12 FORMAT('0',5X,'CONDITION 9',//
     25X,' Number of cumulative days that MCS is dry in some',/
     35X,' or all parts when soil temperature is >5 degrees C.',/
     45X,' Condition is met when this number is < 60% of the time',/
     55X,' that the soil temperature is >5 degress C. The frequency',/
     65X,' should be > 50 % and is diagnostic for some subgroups'/
     75X,' of Alfisols, Inceptisols and Mollisols.')
      WRITE (6,13)
   13 FORMAT('0',5X,'CONDITION 10',//
     25X,' Number of cumulative days that MCS is completely dry when',/
     35X,' soil temperature is >5 degrees C. This number should be >',/
     45X,' 3/4 time that soil temperature is above 5. Condition',/
     55X,' is used for definitions of subgroups of ARIDISOLS and',/
     65X,' the frequency should be > 50 %.')
      WRITE (6,14)
   14 FORMAT('0',5X,'CONDITION 11',//
     25X,' The mean soil temperature is less than 22 degrees C. 50%',/
     35X,' or higher is the critical frequency for XERIC.') 
      WRITE (6,15)
   15 FORMAT('0',5X,'CONDITION 12',//
     25X,' The difference between the winter and summer temperatures',/
     35X,' is equal or larger than 6 degrees C. The frequency of',/
     45X,' occurrence is set at 50% or higher. The condition is',/
     55x,' diagnostic for XERIC.')
      WRITE (6,16)
   16 FORMAT('0',5X,'CONDITION 13',//
     25X,' The number of days that the soil temperature is higher',/
     35X,' than 5 or 8 degrees C is greater than zero. It is used ',/
     45X,' in the definition of ARIDIC. The frequency is set at 50%',/
     55X,' or higher.')
      WRITE (6,17)
   17 FORMAT('0',5X,'CONDITION 14',//
     25X,' The temperature regime is neither pergelic nor cryic',/
     25x,' The condition is required for USTIC with 50% minimum.')
      RETURN
      END
